import urllib2
import uno
import unohelper
from com.accopensys.quant import XQuant


class QuantImpl(unohelper.Base, XQuant):
    def __init__(self, ctx):
        self.ctx = ctx

    def lastprice(self, ticker):
        URL = 'http://finance.yahoo.com/d/quotes.csv?s=%s&f=l1'
        try:
            resp = urllib2.urlopen(URL % ticker).read()
            val = float(resp.strip())
        except:
            return 0.
        else:
            return val


def createInstance(ctx):
    return QuantImpl(ctx)


g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(
    createInstance,
    "com.accopensys.quant.python.QuantImpl",
    ("com.sun.star.sheet.AddIn",))

